(ns com.aurellem.gb-driver
  (:import com.aurellem.gb.Gb)
  (:import (java.nio IntBuffer ByteOrder)))

(defn vba-init []
  (Gb/loadVBA)
  (future
    (Gb/startEmulator "/home/r/proj/pokemon-escape/roms/yellow.gbc")))

(defn get-ram []
  (let [ram-store (int-array (Gb/getRAMSize))]
    (Gb/getRAM ram-store)
    ram-store))

(defn get-rom []
  (let [rom-store (int-array (Gb/getROMSize))]
    (Gb/getRAM rom-store)
    rom-store))

(defn get-working-ram []
  (let [ram-store (int-array Gb/WRAM_SIZE)]
    (Gb/getWRAM ram-store)
    ram-store))

(defn get-video-ram []
  (let [ram-store (int-array Gb/VRAM_SIZE)]
    (Gb/getVRAM ram-store)
    ram-store))

(defn get-registers []
  (let [register-store (int-array Gb/NUM_REGISTERS)]
    (Gb/getRegisters register-store)
    register-store))